设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 350|回复: 3

[标注] 批量标注线段长度插件

[复制链接]
发表于 2021-6-2 17:21:00 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
我有一个批量标注线段长度的插件,很好用,但是使用会出下面这样的提示(不影响使用),想知道怎么解决,希望大佬指点一下
QQ图片20210602172013.png
  1. (defun c:gt()
  2.   (COMMAND "UCS" "")
  3.   (setvar "DIMZIN" 0)
  4.   (setvar "BLIPMODE" 0)
  5.   (setvar "HIGHLIGHT" 1)
  6.   (setvar "CMDECHO" 0)
  7.   (setvar "osmode" 0)
  8.   (setq AcadObject (vlax-get-acad-object)
  9.     AcadDocument (vla-get-ActiveDocument Acadobject)
  10.     mSpace (vla-get-ModelSpace Acaddocument)
  11.   )
  12.   ;;选取需要测量的样条曲线、圆弧、直线、椭圆
  13.   (setq en (ssget (list '(0 . "spline,arc,line,ellipse,LWPOLYLINE"))))
  14.   (setq i 0)
  15.   ;;获取系统参数textsize
  16.   (setq shh (getvar "textsize"))
  17.   (setq str_hh (strcat "\n文字高度 <" (rtos shh 2) ">: "))
  18.   (setq hh (getdist str_hh))
  19.   (while hh
  20.     (setvar "textsize" hh)
  21.     (setq hh nil))
  22.   ;;输入标注文字高度
  23.   ;;循环开始
  24.   (repeat (sslength en)
  25.     (setq ss (ssname en i))
  26.     (setq endata (entget ss))
  27.     (command "lengthen" ss "")
  28.     (setq dd (getvar "perimeter"))
  29.     (princ (strcat "\n长度=" (rtos dd 2 3)))
  30.     ;;寻找代表图层的字符串
  31.     (setq aa (assoc 0 endata))
  32.     ;;获取图层名称
  33.     (setq aa1 (cdr aa))
  34.     ;;判断线条种类
  35.     (cond
  36.       ((= aa1 "SPLINE")
  37.         ;;如果是spline
  38.         (progn
  39.           (setq arcObj (VLAX-ENAME->VLA-OBJECT ss))
  40.           (setq startPnt1 (vla-get-ControlPoints arcObj))
  41.           (setq p1
  42.             (vlax-safearray->list (vlax-variant-value startPnt1))
  43.           )
  44.           (setq x1 (car p1))
  45.           (setq y1 (cadr p1))
  46.           (setq z1 (caddr p1))
  47.           (setq pp1 (list x1 y1 z1))
  48.           (repeat (- (/ (length p1) 3) 1)
  49.             ;;循环,寻找最后一个控制点
  50.             (setq p1 (cdddr p1))
  51.             (setq x2 (car p1))
  52.             (setq y2 (cadr p1))
  53.             (setq z2 (caddr p1))
  54.           )
  55.           (setq pp2 (list x2 y2 z2))
  56.         )
  57.       )
  58.       ((= aa1 "LWPOLYLINE")
  59.         ;;如果是LWPOLYLINE
  60.         (progn
  61.           (setq arcObj (VLAX-ENAME->VLA-OBJECT ss))
  62.           (setq startPnt1 (vla-get-Coordinates arcObj))
  63.           (setq p1
  64.             (vlax-safearray->list (vlax-variant-value startPnt1))
  65.           )
  66.           (setq x1 (car p1))
  67.           (setq y1 (cadr p1))
  68.           (setq z1 (caddr p1))
  69.           (setq pp1 (list x1 y1 z1))
  70.           (repeat (- (/ (length p1) 3) 1)
  71.             ;;循环,寻找最后一个控制点
  72.             (setq p1 (cdddr p1))
  73.             (setq x2 (car p1))
  74.             (setq y2 (cadr p1))
  75.             (setq z2 (caddr p1))
  76.           )
  77.           (setq pp2 (list x2 y2 z2))
  78.         )
  79.       )
  80.       (t
  81.         ;;如果是其他种类线条
  82.         (progn
  83.           (setq arcObj (VLAX-ENAME->VLA-OBJECT ss))
  84.           (setq startPnt1 (vla-get-StartPoint arcObj))
  85.           ;;获取起点
  86.           (setq endPnt1 (vla-get-EndPoint arcObj))
  87.           ;;获取终点
  88.           (setq pp1
  89.             (vlax-safearray->list (vlax-variant-value startPnt1))
  90.           )
  91.           (setq
  92.             pp2 (vlax-safearray->list (vlax-variant-value endPnt1))
  93.           )
  94.         )
  95.       )
  96.     )
  97.     (setq x1 (car pp1))
  98.     (setq y1 (cadr pp1))
  99.     (setq z1 (caddr pp1))
  100.     (setq x2 (car pp2))
  101.     (setq y2 (cadr pp2))
  102.     (setq z2 (caddr pp2))
  103.     (setq x (/ (+ x1 x2) 2))
  104.     (setq y (/ (+ y1 y2) 2))
  105.     (setq z (/ (+ z1 z2) 2))
  106.     (setq pt (list x y z))
  107.     ;;取得线段两端的中点
  108.     (setq ang (angle pp1 pp2))
  109.     ;;获取角度
  110.     (if    (> (* (/ ang pi) 180) 180)
  111.       (setq ang (+ ang pi))
  112.     )
  113.     (command "text"
  114.       "j"
  115.       "bc"
  116.       pt
  117.       ""
  118.       (* (/ ang pi) 180)
  119.       (strcat "" (rtos dd 2 3))
  120.       ""
  121.     )
  122.     (setq i (1+ i))
  123.   )
  124.   (setvar "osmode" 487)
  125.   (princ "线段长度标注已完成")
  126.   (princ)
  127. )


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 64个

财富等级: 招财进宝

发表于 2021-7-11 15:31:07 | 显示全部楼层
批量标注线段长度插件,不错的插件。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 2个

财富等级: 恭喜发财

发表于 2021-8-10 17:16:11 | 显示全部楼层
可以批量标注半径弧长吗?
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 10个

财富等级: 恭喜发财

发表于 2021-8-12 07:39:19 | 显示全部楼层
批量标注线段长度插件,不错的插件。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2021-9-25 17:35 , Processed in 0.725048 second(s), 37 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2020, Tencent Cloud.

快速回复 返回顶部 返回列表